import { splitProps } from "solid-js";
import { mergeRefs } from "@solid-primitives/refs";
import { createCodeMirror } from "@solid-codemirror/core";
import { createExtensions, createLineNumbers, createReadOnly, createTheme, createWrapLine } from "./utils";
export function CodeMirror(props) {
    let ref;
    const [codemirrorProps, lineNumberProps, readOnlyProps, wrapLineProps, extensionProps, themeProps, others] = splitProps(props, ["value", "onValueChange", "onEditorMount"], ["showLineNumbers"], ["readOnly"], ["wrapLine"], ["extensions"], ["theme"]);
    const { createExtension } = createCodeMirror(codemirrorProps, () => ref);
    createLineNumbers(lineNumberProps, createExtension);
    createReadOnly(readOnlyProps, createExtension);
    createWrapLine(wrapLineProps, createExtension);
    createTheme(themeProps, createExtension);
    createExtensions(extensionProps, createExtension);
    return <div ref={mergeRefs(el => (ref = el), props.ref)} {...others}/>;
}
