import { lineNumbers } from "@codemirror/view";
import { createEffect, mergeProps, on } from "solid-js";
export function createLineNumbers(props, createExtension) {
    const merged = mergeProps({ showLineNumbers: true }, props);
    const reconfigureLineNumbers = createExtension(getLineNumbers(merged.showLineNumbers));
    createEffect(on(() => merged.showLineNumbers, (showLineNumbers) => {
        reconfigureLineNumbers(getLineNumbers(showLineNumbers));
    }, { defer: true }));
}
function getLineNumbers(showLineNumbers) {
    return showLineNumbers ? lineNumbers() : [];
}
