import { EditorView, highlightActiveLine, highlightActiveLineGutter, } from "@codemirror/view";
import { createEffect, mergeProps, on } from "solid-js";
export function createReadOnly(props, createExtension) {
    const merged = mergeProps({ readOnly: false }, props);
    const reconfigureLineNumbers = createExtension(getReadOnly(merged.readOnly));
    createEffect(on(() => merged.readOnly, (readOnly) => {
        reconfigureLineNumbers(getReadOnly(readOnly));
    }, { defer: true }));
}
function getReadOnly(readOnly) {
    return readOnly
        ? EditorView.editable.of(false)
        : [highlightActiveLine(), highlightActiveLineGutter()];
}
