import { EditorView } from "@codemirror/view";
import { createEffect, mergeProps, on } from "solid-js";
export function createWrapLine(props, createExtension) {
    const merged = mergeProps({ wrapLine: false }, props);
    const reconfigureWrapLine = createExtension(getWrapLine(merged.wrapLine));
    createEffect(on(() => merged.wrapLine, (wrapLine) => {
        reconfigureWrapLine(getWrapLine(wrapLine));
    }, { defer: true }));
}
function getWrapLine(wrapLine) {
    return wrapLine ? EditorView.lineWrapping : [];
}
